package net.openid.conformance.openbanking_brasil.testmodules.phase3.automaticPayments.abstractModule;

import net.openid.conformance.openbanking_brasil.testmodules.phase3.automaticPayments.AbstractAutomaticPaymentsAutomaticPixUnhappyConsentPathTestModule;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.createRecurringConfigurationObject.AbstractCreateRecurringConfigurationObject;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.createRecurringConfigurationObject.automatic.CreateAutomaticRecurringConfigurationObjectTrimestral;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.editConsentBody.editAutomaticRecurringConfigurationObject.EditRecurringPaymentsAutomaticConsentBodyToSetFirstPaymentDateToThePast;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.editConsentBody.editAutomaticRecurringConfigurationObject.EditRecurringPaymentsAutomaticConsentBodyToSetInvalidFixedAmount;
import net.openid.conformance.openbanking_brasil.testmodules.support.paymentsv2.ensureErrorResponse.EnsureErrorResponseCodeFieldWasDataPagamentoInvalida;
import net.openid.conformance.openbanking_brasil.testmodules.support.paymentsv2.ensureErrorResponse.EnsureErrorResponseCodeFieldWasParametroInvalido;

public abstract class AbstractAutomaticPaymentsApiAutomaticPixInvalidParametersTestModule extends AbstractAutomaticPaymentsAutomaticPixUnhappyConsentPathTestModule {

	@Override
	protected void performTestSteps() {
		performTestStep(
			", sending fixedAmount as a string \"1\"",
			EditRecurringPaymentsAutomaticConsentBodyToSetInvalidFixedAmount.class,
			EnsureErrorResponseCodeFieldWasParametroInvalido.class
		);

		performTestStep(
			", and firstPayment date as D-1",
			EditRecurringPaymentsAutomaticConsentBodyToSetFirstPaymentDateToThePast.class,
			EnsureErrorResponseCodeFieldWasDataPagamentoInvalida.class
		);
	}

	@Override
	protected AbstractCreateRecurringConfigurationObject consentBodyCondition() {
		return new CreateAutomaticRecurringConfigurationObjectTrimestral();
	}
}
